﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Sandbox.Interfaces.Models.Abstract;

namespace Sandbox.Interfaces.Repositories.Abstract
{
  public interface IEntityRepository<T> where T: IEntity
  {
    Task<T> Create(T instance);
    Task<T> Retrieve(int id);
    Task<T> Update(T instance);
    void Delete(T instance);
    Task<IQueryable<T>> RetrieveAll();
  }
}